import * as DataType from 'sequelize'

export default {
  tableName: 'notes',
  modelName: 'Note',
  options: {
    timestamps: true,
    paranoid: true,
    createdAt: 'createdAt',
    updatedAt: 'updatedAt',
    deletedAt: 'deletedAt',
  },
  rawAttributes: {
    id: {
      allowNull: true,
      primaryKey: true,
      type: DataType.UUIDV4,
    },
    title: {
      allowNull: false,
      type: DataType.STRING,
    },
    content: {
      allowNull: true,
      type: DataType.TEXT({ length: 'long', }),
    },
    folderId: {
      allowNull: true,
      type: DataType.UUIDV4,
    },
    createdAt: {
      allowNull: false,
      type: DataType.DATE,
    },
    updatedAt: {
      allowNull: false,
      type: DataType.DATE,
    },
    deletedAt: {
      allowNull: true,
      type: DataType.DATE,
    },
  },
}

// import 'reflect-metadata'
// import {
//   AllowNull,
//   BelongsTo,
//   Column,
//   CreatedAt,
//   DeletedAt,
//   ForeignKey,
//   Model,
//   PrimaryKey,
//   Table,
//   UpdatedAt,
//   DataType,
// } from 'sequelize-typescript'
// import Folder from './Folder'
//
// @Table({
//   timestamps: true,
//   paranoid: true,
// })
// export default class Model extends Model<Model> {
//   @AllowNull
//   @PrimaryKey
//   @Column(DataType.UUIDV4)
//   id?: string
//
//   @Column
//   title: string
//
//   @AllowNull
//   @Column(DataType.TEXT({ length: 'long' }))
//   content?: string
//
//   @AllowNull
//   @ForeignKey(() => Folder)
//   @Column(DataType.UUIDV4)
//   folderId?: string
//
//   @BelongsTo(() => Folder, 'folderId')
//   folder?: Folder
//
//   @Column(DataType.DATE)
//   @CreatedAt
//   createdAt: Date
//
//   @Column(DataType.DATE)
//   @UpdatedAt
//   updatedAt: Date
//
//   @AllowNull
//   @Column(DataType.DATE)
//   @DeletedAt
//   deletedAt?: Date
// }
